//+------------------------------------------------------------------------------+ 
//|                           Terminator vTSD-4.11.mq4                           | 
//+------------------------------------------------------------------------------+
//|  Private version based on the following EA:                                  |
//|                                                                              |
//|                           DLM1.1 of Alejandro Galindo, http://elCactus.com   |
//|                           Terminator v2.02 of Tom Maneval                    |
//|                           Phoenix of Hendrick Stam                           |
//|                                                                              |
//|           Security Mods, Margin Protection, Phoenix Implementation,          |
//|             Dinamic range calculator, Swap Trading Direction and             |
//|                        several others mods done by:                          |  
//|                                                                              |
//|                                 Project1972                                  |
//|                   and a special collaboration of Tom Maneval                 |
//|                                                                              |
//|    Copyright  Project1972 for http://www.forex-tsd.com Elite Section        |
//|                                                                              |
//|     You are NOT ALLOWED to distribute this EA in any public forum            |
//|                                                                              |
//|             WARNING, Risky Martingale EA, Use it at your risk                |
//|     Current default Settings were determined after many months of testing    |
//|                             Use on H1 Timeframe                              |
//+------------------------------------------------------------------------------+
#property copyright "Copyright  2005,2006 Alejandro Galindo, Tom Maneval and Project1972"
#property link      "http://www.forex-tsd.com"

extern int    Manual=0;                      // If set to one then it will not open new trades but it will continue with already opened positions
extern bool   CloseAllOpenTradesNow=False;   // WARNING If true, then the expert will close all open trades NOW and will not open new ones.
extern bool   CloseAllProfitTradesNow=False; // If true, we will close all trades with at least MinPipsProfit
extern int    MinPipsProfit=22;              // Minimal Profit to execute CloseAllProfitTradesNow
//--------------------------------------------------------------------------------------------------------------------------------------------
//-- Soft Account Protection --- If any of of those following alarm trigger EA will stop opening new trades but it don't generate losses------
//--------------------------------------------------------------------------------------------------------------------------------------------
extern int    ForceAccountProtection=0;     // If set to one then AccountProtection function will be active all the time.
extern int    FloatingLossProtection=1;     // Percent of FLOATING LOSS to stop opening new positions after closed ones(Percent of Balance)
extern double MarginProtection  = 99.5;       // Percent of free margin to stop opening new positions after closed ones
extern double MarginProtection2 = 80;       // Percent of free margin to START AccountProtection Function
extern bool   SpreadProtection  = True;     // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance      = 2;        // value in pips over normal spread to activate the SpreadProtection
// WARNING, the value of normal spread is taken during the initialization, Start the EA ONLY on calm markets or the value of normal spread can be wrong 
//----------------------------------------------------------------------------------------------------------------------------------------------
//-- WARNING -- Hard Account Protection --- WARNING-- If one of those folowing alarm trigger EA WILL CLOSE all opened positions at Market-------
//-- WARNING - It can generate extreme losses and are intended for limit a further loss in a strong trending market against our positions-------
//----------------------------------------------------------------------------------------------------------------------------------------------
extern bool   EquityProtection=True;                  // if true, then the expert will protect the account equity to the percent specified
extern int    AccountEquityPercentProtection= 90;      // percent of the account Equity left to activate a hard stop loss on a set of trades
extern bool   AccountMoneyProtection=False;            // if true, then the expert will protect the account money to the amount specified
extern double AccountMoneyProtectionValue= 50000.00;   // Amount of Equity money To Trigger a Hard Stop Loss on ALL trades.This is a final Stop loss.
extern bool   CloseOnTrendRev=False;
//===================================================================================================================================================
extern double Lots              = 0.1;     // We start with this lots number
extern double LotIncreaseFactor = 2;       // increase Martingale lots based on this multiplier
extern bool   UseFibonacciProgression=True;// If true we will use a Fibonacci algorithm in the martingale progression
extern double StopLoss          = 0;       // StopLoss
extern double Trailing_Stop     = 25;      // Pips to trail the StopLoss
extern double BreakevenTrail    = 40;      // Pips earned to start to trail the StopLoss
//===================================================================================================================================================
extern int    MaxTrades            =8;     // Maximum number of orders to open
extern int    AccountProtection    =1;      // If one the account protection will be enabled, 0 is disabled
extern int    AllSymbolsProtect    =0;      // If one will check profit from all symbols, if zero only this symbol
extern int    OrderstoProtect      =1;      // This number subtracted from MaxTrades is the number of open orders to enable the account protection.
                                            // Example: (MaxTrades=10) minus (OrderstoProtect=3)=7 orders need to be open before account protection is enabled.
extern bool   ReverseCondition=False;       // If True the decision to go long/short will be reversed
extern int    StartYear=2001;               // Year to start (only for backtest)
extern int    StartMonth=1;                 // Month to start (only for backtest)
extern int    EndYear=2030;                 // Year to stop trading (backtest and live)
extern int    EndMonth=12;                  // Month to stop trading (backtest and live)
extern bool   mm=True;                      // if True the lots size will increase based on account size (I don't recomend use MM with a martingale EA)
extern double risk=0.1;                     // risk to calculate the lots size (only if mm is enabled)
extern int    MagicNumber=222777;           // Magic number for the orders placed
extern bool   TradePositiveSwapOnly=True;  // If true we will trade only in the direction of positive interest, if false, both ways                                         
extern int    FixedDirection       =0;      // 0=Both Ways, 1= Longs only 2= Short Only,  if different of 0 then TradePositiveSwapOnly is override                                        
extern bool   DontTradeOnFriday=False;      // If true we will not start new positions on Friday (This is because some brokers don't want open trades over the weekend)
extern bool   PrefSettings     = True;      // If PrefSettings=true we will look for predefined settings for each symbol in the expert initialization function.
//
//================================= Enter Confirmation =============================================================================
//
extern bool   Use_EnterConfirmation=True;     // If true we will use a signal to confirm each position of the martingale progression
extern double Timeframe1           = 0;      // TimeFrame to use in the enter indicator
//                                            // 0 for actual TF or 1,5,15,30,60,240,1440 for 1 minute,5,15,30,60 minutes,240,1440 for 4H and Diary Timeframe
//=============================== End Enter Confirmation ===========================================================================
//
//=============================== Exit Confirmation =============================================================================
//
extern bool   Use_ExitConfirmation=True;     // If true we will use a signal to exit each position if it is in profit
extern double Timeframe2           = 0;     // 0 for actual TF or 1,5,15,30,60,240,1440 for 1 minute,5,15,30,60 minutes,240,1440 for 4H and Diary Timeframe
//
//============================== End Exit Confirmation ==========================================================================
//
//
//=================================AutoSetup Parameters==============================================================================================
//
//   If AutoSetup=true Then the value of Pips, Take Profit, and Secure Profit are taken directly from the chat by a Dinamic Range Calculator
//   If false you have to set Pips, Take Profit, and Secure Profit manually.
//
extern bool   AutoSetup       = true;	   //Set to false if you want to set Pips, Take Profit, and Secure Profit manually.
//
extern double SafeRangeFactor = 2;      // Used to multiply the Average Diary Range in order to be safe
extern double SafeMinRange    = 350;      // Safe Minimal Range in this Symbol, Used to replace the value of Safe Trading Range if it is below this value
//                                        // or the Historical Diary Data doesn't exist or is corrupted.
//Example, if the Average Diary Range is 100 pips and SafeRangeFactor=1.9 then we will operate with a 100x1.9 = 190 pips of range
extern double TakeProfitMT   =6;          // TakeProfit calculation Pips*TakeProfitMT.  Should be more than 1 but probably not more than 2. Example 1.75
extern double SecureProfitMT =1.1;        // PipsSecureProfit calculation Pips*PipMultiple. Should be between 1 and 2. Example 1.1
//
//==================================Manual Parameters(If AutoSetup=False)=================================================================================================================
//
extern double TakeProfit1     =84;           // Profit Goal for the First order opened
extern int    Pips1           =18;           // Distance in Pips from first order to second
extern double TakeProfit2     =64;           // Profit Goal for the 2^ order opened
extern int    Pips2           =18;           // Distance in Pips from 2^ order to 3^
extern double TakeProfit3     =42;           // Profit Goal for the 3^ order opened
extern int    Pips3           =18;           // Distance in Pips from 3^ order to 4^
extern double TakeProfit4     =22;           // Profit Goal for the 4^ order opened
extern int    Pips4           =19;           // Distance in Pips from 4^ order to 5^
extern double TakeProfit5     =22;           // Profit Goal for the 5^ order opened
extern int    Pips5           =19;           // Distance in Pips from 5^ order to 6^
extern double TakeProfit6     =22;           // Profit Goal for the 6^ order opened
extern int    Pips6           =20;           // Distance in Pips from 6^ order to 7^
extern double TakeProfit7     =22;           // Profit Goal for the 7^ order opened
extern int    Pips7           =20;           // Distance in Pips from 7^ order to 8^
extern double TakeProfit8     =22;           // Profit Goal for the 8^ order opened
extern int    Pips8           =20;           // Distance in Pips from 8^ order to 9^
extern double TakeProfit9     =22;           // Profit Goal for the 9^ order opened
extern int    Pips9           =20;           // Distance in Pips from 9^ order to 10^ and following orders
extern double TakeProfit10    =22;           // Profit Goal for the 10^ and following order opened 
extern int    PipsSecureProfit=25;           // If profit made is bigger than SecureProfit we close the orders
//===================================================================================================================================================
//
//========== OpenOrdersBasedOn is the Signals Method used to open trades. This is the most important decision===================
//
//         Some Method require and aditional Indicator, and some work better in one symbol and worst in others
//
//                                 ============ TREND FOLLOWING METHODS ===================
//
//          List of methods to start opening trend following positions (Buy the High, Sell the Low) 
//
//     0=MACD                            --------No indicator required, use MACD indicator of Metaquotes, MACD have 5 modes of operation
//     1=Pivot Point Time Zone,          --------Require indicator "Pivot Lines TimeZone"
//     2=Support and Resistance          --------Require indicator "Support and Resistance",
//     3=Turbo_JRSX                      --------Require indicator "Turbo_JRSX"
//     4=i_Trend RSI                     --------Require indicator "i_Trend"
//     5=i_TrendRSIStoch                 --------Require indicator "i_Trend"
//     6=i-TrendRSIStochMoneyFlowIndex   --------Require indicator "i_Trend"
//     7=PSAR                            --------No indicator required, use Parabolic SAR indicator of Metaquotes
//     8=BrainTrend1Sig                  --------Require indicator "BrainTrend1Signal"
//     9=RSI2MA                          --------Require indicator "RSI 2MA"
//     10=MovingAverage                  --------No indicator required, use Moving Average indicator of Metaquotes
//     11=CCI                            --------No indicator required, use Commodity Channel Index indicator of Metaquotes
//     12=BullsandBears                  --------No indicator required, use Bulls and Bears Power indicator of Metaquotes
//     13=TrendManager                   --------Require indicator "Trend Manager"
//     14=FXFish                         --------Require indicator "FX_FISH"
//     15=FXFish2-MA                     --------Require indicator "FX_FISH2_MA"
//     16=FibPivots                      --------No indicator Required, it is coded in the EA
//     17=Fib4Hour                       --------No indicator Required, it is coded in the EA
//     18=ZLS                            --------Require indicator "Zerolagstochs"
//     19=OnChopZone                     --------Require indicator "ChopZone"
//     20=DZRSI                          --------Require indicator "Dynamic Zone RSI"
//     21=Profit Generator               --------No indicator Required, it is coded in the EA
//     25=Ichimoku                       --------No indicator required, use Ichimoku of Metaquotes
//
//                                     ============ COUNTERTREND METHODS ===================
//
//          List of methods to start opening countertrend positions (Buy the Low, Sell the High)
//
//     22=Bollinger Bands and RSI        --------No indicator Required, it is coded in the EA
//     23=Firebird Signal                --------No indicator Required, it is coded in the EA
//     24=Phoenix Signal                 --------No indicator Required, it is coded in the EA
//
//The first position ALWAYS WILL be checked against a 4H Moving Average Filter in ALL Methods, We WILL NOT open first Positions against the 4H Trend or in undefined trend.
//
extern int  OpenOrdersBasedOn=25;          // Method to Open Positions
extern int  TimeZone=0;                   // Time zone to calculate the pivots (only used in method 1 )
//
//====================== TimeFilter Settings, it use your Local Time, adjust according. 4 Time windows can be defined============================
//
extern string     TimeFilter              = "====== TimeFilter Settings ===========================";
extern bool       UseTimeFilter           = False;
extern int        TradeFrom1              = 0;
extern int        TradeUntil1             = 24;
extern int        TradeFrom2              = 0;
extern int        TradeUntil2             = 0;
extern int        TradeFrom3              = 0;
extern int        TradeUntil3             = 0;
extern int        TradeFrom4              = 0;
extern int        TradeUntil4             = 0;
//
//
//============================== End Exit Confirmation ==========================================================================
//
//===================== OpenOrdersBasedOn=20 =  PHOENIX SIGNAL SETTINGS ==========================================================
//
// If PrefSettings=true we will look for predefined settings for each symbol in the expert initialization function.
// If PrefSettings=false or settings for this symbol is not found in expert initialization function then we use default settings
//
extern string     PHOENIX_SIGNAL          = "====== PHOENIX SIGNAL ============================";
//
//========================= Default Settings for Phoenix Signal 1 ==============================
//
extern string     Signal1                 = "====== Signal 1 ===================================";
extern bool       UseSignal1              = true;
extern double     PhoenixPercent          = 0.0032;
extern int        EnvelopePeriod          = 2;
//
//========================= Default Settings for Phoenix Signal 2 =============================
//
extern string     Signal2                 = "====== Signal 2 ==================================";
extern bool       UseSignal2              = true;
extern int        SMAPeriod               = 2;
extern int        SMA2Bars                = 18;
//
//========================= Default Settings for Phoenix Signal 3 ==============================
//
extern string     Signal3                 = "====== Signal 3 ==================================";
extern bool       UseSignal3              = true;
extern int        OSMAFast                = 5;
extern int        OSMASlow                = 22;
extern double     OSMASignal              = 2;
//
//========================= Default Settings for Phoenix Signal 4 ==============================
//
extern string     Signal4                 = "====== Signal 4 ==================================";
extern bool       UseSignal4              = true;
extern int        Fast_Period             = 25;
extern int        Fast_Price              = PRICE_OPEN;
extern int        Slow_Period             = 15;
extern int        Slow_Price              = PRICE_OPEN;
extern double     DVBuySell               = 0.0029;
extern double     DVStayOut               = 0.024;
//
//============================ END PHOENIX SIGNAL SETTINGS =============================================================================================================================================================
//
//
//===================== OpenOrdersBasedOn=19 =  FIREBIRD SIGNAL SETTINGS ================================================================================================================================================
//
extern string     FIREBIRD_SIGNAL        = "====== FIREBIRD SIGNAL ===========================";
extern int        MA_length              = 10;
extern int        MA_timeframe           = 0;
extern double     FirebirdPercent        = 0.3;
//
//====  By design Firebird generate a countertrend signal, but we can invert signals during news hours if we want to =====================================================================================================
//
extern bool TrendFollowingDuringNewsTime  =False;  // If true EA will open TrendFollowing Position During News Time, if false all the positions are CounterTrend like the original Firebird.
extern int  NewsHourFrom                  = 8;     // Starting of news time, If TrendFollowing is enable we will open Trend Following Positions After this time.(buy the High and sell the low) Good for trending markets
extern int  NewsHourUntil                 = 18;    // Final of News Time, we will start positions against the trend.(buy the low and sell the High) Good for ranging markets
//
//===================================END FIREBIRD SIGNAL SETTINGS=========================================================================================================================================================
//
//===================== OpenOrdersBasedOn=0 MACD SIGNAL SETTINGS ================================
//
//     There are five MACD SIGNALS, MODE1 give an inmediate signal when is above or below zero
//                                  MODE2 give a signal when is well above or well below zero
//                                  MODE3 use MACD with an EMA confirmation.
//                                  MODE4 use JMA_MACD (require JMA.mq4 and JMA_MACD.mq4 indicator)
//                                  MODE5 use Turbo JMACD (Requires indicator Turbo_JMACD) 

//
extern string     MACD_SIGNAL             = "MACD 1=Fast,2=Slow,3=MACD+EMA,4=JMA MACD,5=Turbo_JMACD";
extern int        MACD_Mode               = 3;     // Select 1=Fast, 2=Slow, 3=MACD+EMA 4=JMA MACD
extern int        emaFast                 = 12;    // parameters for MACD
extern int        emaSlow                 = 26;    // parameters for MACD
extern int        signalPeriod            = 9;     // parameters for MACD
extern int        timeFrame               = 0;     // parameters for MACD
extern int        EMAperiod               = 34;    // the length of the EMA. Only used in mode 3
//
//==================================== END MACD SIGNAL SETTINGS ==================================
//
//
//=================================== Variables Initialization ==================
//
int  OpenOrders=0,trendtype=0,TrendType=0;
int  slippage=3,WorstRange=0,MinTS=0;
double sl=0, tp=0, StopTrading=0, StopTrading2=0, ProtectionActivate=0;
double BuyPrice=0, SellPrice=0, TakeProfit=0;
double lotsi=0, mylotsi=0, Pips=0,Spread=0,WorstSpread=0,NormalSpread=0;
double TotalSwap=0,TotalCommission=0;
double TotalProfit=0;
int mode=0,myOrderType=0,myOrderTypetmp=0,Stoch1=0,Stoch2=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0,EnterConfirmation=0,ExitConfirmation=0;
double SecureProfit=0,Pips_even=0,MinLots=0,LotStep=0,MaxLots=0;
double VariableSpread=0; 
double Profit=0, swaplong=0, swapshort=0;
int LastTicket=0, LastType=0, DontContinue=0;
double LastClosePrice=0, LastLots=0;
double Pivot=0, DontStart=0, DontStart2=1;
double PipValue=0, TrendingMarket=1;
bool AccountisNormal,Reversed=False,DinamicRangeCalc=false;
string text="",text2="",TradeDirection="",TrendTxt="";
string text3="",text4="",WeTradeIt="Both ways",AccountText="";
string text6="",OrdersBasedOn="";
double tmp=0, SafeTradingRange=0;
double iTmpH=0,DnTrendVal=0,UpTrendVal=0,TrendVal=0;
double iTmpL=0,SecureProfit2=0;
int RSX_Period=17,lotsize;
bool dummyResult;
//
//================================End Variables Initialization==================
//
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
//+------------------------------------------------------------------+
//| PHOENIX START Preferred Settings                                 |
//+------------------------------------------------------------------+
if(PrefSettings == true)
{
   if((Symbol() == "USDJPY") || (Symbol() == "USDJPYm"))
      {     
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0032;
      EnvelopePeriod       = 2;
      SMAPeriod            = 2;
      SMA2Bars             = 18;
      OSMAFast             = 5;
      OSMASlow             = 22;
      OSMASignal           = 2;
      Fast_Period          = 25;
      Slow_Period          = 15;
      DVBuySell            = 0.0029;
      DVStayOut            = 0.024;
      SafeMinRange         = 350;   
      }

   if((Symbol() == "EURJPY") || (Symbol() == "EURJPYm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.007;
      EnvelopePeriod       = 2;
      SMAPeriod            = 4;
      SMA2Bars             = 16;
      OSMAFast             = 11;
      OSMASlow             = 20;
      OSMASignal           = 14;
      Fast_Period          = 20;
      Slow_Period          = 10;
      DVBuySell            = 0.0078;
      DVStayOut            = 0.026;
      SafeMinRange         = 360;
      }

   if((Symbol() == "GBPJPY") || (Symbol() == "GBPJPYm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0072;
      EnvelopePeriod       = 2;
      SMAPeriod            = 8;
      SMA2Bars             = 12;
      OSMAFast             = 5;
      OSMASlow             = 36;
      OSMASignal           = 10;
      Fast_Period          = 17;
      Slow_Period          = 28;
      DVBuySell            = 0.0034;
      DVStayOut            = 0.063;
      SafeMinRange         = 580;
      }
      
   if((Symbol() == "USDCHF") || (Symbol() == "USDCHFm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0056;
      EnvelopePeriod       = 10;
      SMAPeriod            = 5;
      SMA2Bars             = 9;
      OSMAFast             = 5;
      OSMASlow             = 12;
      OSMASignal           = 11;
      Fast_Period          = 5;
      Slow_Period          = 20;
      DVBuySell            = 0.00022;
      DVStayOut            = 0.0015;
      SafeMinRange         = 350;
      }
      
   if((Symbol() == "GBPUSD") || (Symbol() == "GBPUSDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0023;
      EnvelopePeriod       = 6;
      SMAPeriod            = 3;
      SMA2Bars             = 14;
      OSMAFast             = 23;
      OSMASlow             = 17;
      OSMASignal           = 15;
      Fast_Period          = 25;
      Slow_Period          = 37;
      DVBuySell            = 0.00042;
      DVStayOut            = 0.05;
      SafeMinRange         = 360;
      } 
     
    if((Symbol() == "EURUSD") || (Symbol() == "EURUSDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.001;
      EnvelopePeriod       = 20;
      SMAPeriod            = 11;
      SMA2Bars             = 50;
      OSMAFast             = 8;
      OSMASlow             = 40;
      OSMASignal           = 10;
      Fast_Period          = 4;
      Slow_Period          = 15;
      DVBuySell            = 0.0003;
      DVStayOut            = 0.006;
      SafeMinRange         = 260;
      } 
   
   if((Symbol() == "EURCHF") || (Symbol() == "EURCHFm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.008;
      EnvelopePeriod       = 4;
      SMAPeriod            = 19;
      SMA2Bars             = 3;
      OSMAFast             = 3;
      OSMASlow             = 30;
      OSMASignal           = 3;
      Fast_Period          = 35;
      Slow_Period          = 80;
      DVBuySell            = 0.0004;
      DVStayOut            = 0.0005;
      SafeMinRange         = 180;
      }
   
   if((Symbol() == "AUDUSD") || (Symbol() == "AUDUSDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.008;
      EnvelopePeriod       = 4;
      SMAPeriod            = 12;
      SMA2Bars             = 2;
      OSMAFast             = 10;
      OSMASlow             = 40;
      OSMASignal           = 2;
      Fast_Period          = 30;
      Slow_Period          = 5;
      DVBuySell            = 0.0004;
      DVStayOut            = 0.0005;
      SafeMinRange         = 300;
      }
   
   if((Symbol() == "USDCAD") || (Symbol() == "USDCADm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0036;
      EnvelopePeriod       = 4;
      SMAPeriod            = 2;
      SMA2Bars             = 2;
      OSMAFast             = 3;
      OSMASlow             = 10;
      OSMASignal           = 3;
      Fast_Period          = 5;
      Slow_Period          = 10;
      DVBuySell            = 0.0005;
      DVStayOut            = 0.001;
      SafeMinRange         = 270;
      }
   
   if((Symbol() == "NZDUSD") || (Symbol() == "NZDUSDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.008;
      EnvelopePeriod       = 4;
      SMAPeriod            = 12;
      SMA2Bars             = 2;
      OSMAFast             = 10;
      OSMASlow             = 40;
      OSMASignal           = 2;
      Fast_Period          = 30;
      Slow_Period          = 5;
      DVBuySell            = 0.0004;
      DVStayOut            = 0.0005;
      SafeMinRange         = 200;
      }
   
   if((Symbol() == "EURGBP") || (Symbol() == "EURGBPm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.034;
      EnvelopePeriod       = 7;
      SMAPeriod            = 10;
      SMA2Bars             = 20;
      OSMAFast             = 9;
      OSMASlow             = 30;
      OSMASignal           = 4;
      Fast_Period          = 25;
      Slow_Period          = 50;
      DVBuySell            = 0.001;
      DVStayOut            = 0.03;
      SafeMinRange         = 180;
      }
   
   if((Symbol() == "CHFJPY") || (Symbol() == "CHFJPYm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.012;
      EnvelopePeriod       = 20;
      SMAPeriod            = 30;
      SMA2Bars             = 4;
      OSMAFast             = 7;
      OSMASlow             = 45;
      OSMASignal           = 8;
      Fast_Period          = 52;
      Slow_Period          = 29;
      DVBuySell            = 0.0016;
      DVStayOut            = 0.034;
      SafeMinRange         = 190;
      }
       
   if((Symbol() == "CADJPY") || (Symbol() == "CADJPYm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.012;
      EnvelopePeriod       = 20;
      SMAPeriod            = 30;
      SMA2Bars             = 4;
      OSMAFast             = 7;
      OSMASlow             = 45;
      OSMASignal           = 8;
      Fast_Period          = 52;
      Slow_Period          = 29;
      DVBuySell            = 0.0016;
      DVStayOut            = 0.034;
      SafeMinRange         = 500;
      }    
    
    if((Symbol() == "GBPCHF") || (Symbol() == "GBPCHFm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.034;
      EnvelopePeriod       = 7;
      SMAPeriod            = 10;
      SMA2Bars             = 20;
      OSMAFast             = 9;
      OSMASlow             = 30;
      OSMASignal           = 4;
      Fast_Period          = 25;
      Slow_Period          = 50;
      DVBuySell            = 0.001;
      DVStayOut            = 0.03;
      SafeMinRange         = 400;
      }  
    
    if((Symbol() == "EURAUD") || (Symbol() == "EURAUDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.004;
      EnvelopePeriod       = 4;
      SMAPeriod            = 2;
      SMA2Bars             = 6;
      OSMAFast             = 4;
      OSMASlow             = 45;
      OSMASignal           = 10;
      Fast_Period          = 20;
      Slow_Period          = 36;
      DVBuySell            = 0.0005;
      DVStayOut            = 0.0009;
      SafeMinRange         = 320;
      }
    
    if((Symbol() == "EURCAD") || (Symbol() == "EURCADm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.004;
      EnvelopePeriod       = 4;
      SMAPeriod            = 2;
      SMA2Bars             = 6;
      OSMAFast             = 4;
      OSMASlow             = 45;
      OSMASignal           = 10;
      Fast_Period          = 20;
      Slow_Period          = 36;
      DVBuySell            = 0.0005;
      DVStayOut            = 0.0009;
      SafeMinRange         = 260;
      }
    
    if((Symbol() == "AUDCAD") || (Symbol() == "AUDCADm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.008;
      EnvelopePeriod       = 4;
      SMAPeriod            = 12;
      SMA2Bars             = 2;
      OSMAFast             = 10;
      OSMASlow             = 40;
      OSMASignal           = 2;
      Fast_Period          = 30;
      Slow_Period          = 5;
      DVBuySell            = 0.0004;
      DVStayOut            = 0.0005;
      SafeMinRange         = 180;
      }
    
    if((Symbol() == "AUDJPY") || (Symbol() == "AUDJPYm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0072;
      EnvelopePeriod       = 2;
      SMAPeriod            = 8;
      SMA2Bars             = 12;
      OSMAFast             = 5;
      OSMASlow             = 36;
      OSMASignal           = 10;
      Fast_Period          = 17;
      Slow_Period          = 28;
      DVBuySell            = 0.0034;
      DVStayOut            = 0.063;
      SafeMinRange         = 260;
      }
    
    if((Symbol() == "NZDJPY") || (Symbol() == "NZDJPYm"))
      {
      FirebirdPercent      = 0.3;
      PhoenixPercent       = 0.0072;
      EnvelopePeriod       = 2;
      SMAPeriod            = 8;
      SMA2Bars             = 12;
      OSMAFast             = 5;
      OSMASlow             = 36;
      OSMASignal           = 10;
      Fast_Period          = 17;
      Slow_Period          = 28;
      DVBuySell            = 0.0034;
      DVStayOut            = 0.063;
      SafeMinRange         = 260;
      }
    
    if((Symbol() == "AUDNZD") || (Symbol() == "AUDNZDm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.008;
      EnvelopePeriod       = 4;
      SMAPeriod            = 19;
      SMA2Bars             = 3;
      OSMAFast             = 3;
      OSMASlow             = 30;
      OSMASignal           = 3;
      Fast_Period          = 35;
      Slow_Period          = 80;
      DVBuySell            = 0.0004;
      DVStayOut            = 0.0005;
      SafeMinRange         = 280;
      }
    
    if((Symbol() == "AUDCHF") || (Symbol() == "AUDCHFm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.034;
      EnvelopePeriod       = 7;
      SMAPeriod            = 10;
      SMA2Bars             = 20;
      OSMAFast             = 9;
      OSMASlow             = 30;
      OSMASignal           = 4;
      Fast_Period          = 25;
      Slow_Period          = 50;
      DVBuySell            = 0.001;
      DVStayOut            = 0.03;
      SafeMinRange         = 190;
      }
    
    if((Symbol() == "CADCHF") || (Symbol() == "CADCHFm"))
      {
      FirebirdPercent      = 0.1;
      PhoenixPercent       = 0.0056;
      EnvelopePeriod       = 10;
      SMAPeriod            = 5;
      SMA2Bars             = 9;
      OSMAFast             = 5;
      OSMASlow             = 12;
      OSMASignal           = 11;
      Fast_Period          = 5;
      Slow_Period          = 20;
      DVBuySell            = 0.00022;
      DVStayOut            = 0.0015;
      SafeMinRange         = 220;
      }                
}
NormalSpread=(Ask-Bid)/Point;
return(0);
}

//+------------------------------------------------------------------+
//| PHOENIX End Preferred Settings                                   |
//+------------------------------------------------------------------+   
//----
  
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {   
   int cnt=0;
   swaplong=NormalizeDouble(MarketInfo(Symbol(),18),2);
   swapshort=NormalizeDouble(MarketInfo(Symbol(),19),2);
   MinTS=NormalizeDouble(MarketInfo(Symbol(),14),0);
   MinLots=NormalizeDouble(MarketInfo(Symbol(),23),2);
   LotStep=NormalizeDouble(MarketInfo(Symbol(),24),2);
   MaxLots=NormalizeDouble(MarketInfo(Symbol(),25),2);
   lotsize=MarketInfo( Symbol(), MODE_LOTSIZE );
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=5; }
   if (lotsize==100000){AccountisNormal=True;} else {AccountisNormal=False;}
   if (lotsize==10000){AccountisNormal=False;}
   if (AccountisNormal==True) {AccountText="Standart";} else {AccountText="Mini";}
   Spread=(Ask-Bid)/Point;
   if (MinTS>Trailing_Stop) {Trailing_Stop=MinTS;}
   double MA3_0 = iMA(NULL, PERIOD_H4, 3, 0, MODE_SMA, PRICE_CLOSE, 0);
   double MA3_1 = iMA(NULL, PERIOD_H4, 3, 0, MODE_SMA, PRICE_CLOSE, 1);
   double MA20_0 = iMA(NULL, PERIOD_H4, 20, 0, MODE_SMA, PRICE_CLOSE, 0);
   double MA20_1 = iMA(NULL, PERIOD_H4, 20, 0, MODE_SMA, PRICE_CLOSE, 8);
   double MA50_0 = iMA(NULL, PERIOD_H4, 50, 0, MODE_SMA, PRICE_CLOSE, 0);
   double MA50_1 = iMA(NULL, PERIOD_H4, 50, 0, MODE_SMA, PRICE_CLOSE, 1);
   double MA100_0 = iMA(NULL, PERIOD_H4, 100, 0, MODE_SMA, PRICE_CLOSE, 0);
   double MA100_1 = iMA(NULL, PERIOD_H4, 100, 0, MODE_SMA, PRICE_CLOSE, 1);
   TrendType=0;
   if (MA100_0<MA100_1 && MA50_0<MA50_1 && MA20_0<MA20_1 && MA3_0<MA3_1 && MA3_0<MA20_0) {TrendType=1;} //downtrend
   if (MA100_0>MA100_1 && MA50_0>MA50_1 && MA20_0>MA20_1 && MA3_0>MA3_1 && MA3_0>MA20_0) {TrendType=2;} //uptrend
   if (Spread>WorstSpread) {WorstSpread=Spread;}
   if (AccountisNormal)
   {
	  if (mm) 
	  { 
	   if (MinLots==1) { lotsi=MathFloor(AccountBalance()*risk/100000); }
	   if (MinLots==0.1) { lotsi=MathFloor(AccountBalance()*risk/10000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/1000)/100; }
	  } 
		else { lotsi=Lots; }
   } else 
   {  // then is mini
    if (mm) 
	  { 
	   if (MinLots==1) { lotsi=MathFloor(AccountBalance()*risk/10000); }
	   if (MinLots==0.1) { lotsi=MathFloor(AccountBalance()*risk/1000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/100)/100; }
	  } 
		else { lotsi=Lots; }
   }
   if (lotsi>MaxLots){ lotsi=MaxLots; }
   if (lotsi<MinLots){ lotsi=MinLots; }
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   if (OpenOrders<1) 
   {
	  if (TimeYear(CurTime())<StartYear) { return(0);  }
	  if (TimeMonth(CurTime())<StartMonth) { return(0); }
	  if (TimeYear(CurTime())>EndYear) { return(0); }
	  if (TimeMonth(CurTime())>EndMonth ) { return(0); }
   }
// 
//======================================SECURITY FUNCTIONS======================================================================= 
//
  if (AccountMoneyProtection==true && AccountEquity()< AccountMoneyProtectionValue)
   {
    text3 = "Closing orders because account money protection was triggered.";
    Print("Closing orders because account money protection was triggered. Balance: ",AccountBalance()," Equity: ",AccountEquity());
    CloseAll();
    ContinueOpening=False;
    DontStart=1;
   }
//
//-----------------------Account equity protection-------------------------------------------------------------------------------- 
//
   if (EquityProtection==true && AccountEquity()<=AccountBalance()*AccountEquityPercentProtection/100) 
	 {
	 text3 = "Closing orders because account equity protection was triggered.";
	 Print("Closing orders because account equity protection was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());	 
	 CloseAll();
	 ContinueOpening=False;
	 DontStart=1;
   }
//
// if we dont trade at fridays we stop opening new positions
//
   if (DontTradeOnFriday==true && DayOfWeek()==5)
   {
    DontStart2=1;
    text4 = "We stop trading because DontTradeOnFriday protection.";
    Print("We stop trading because DontTradeOnFriday protection.");
   } else { DontStart2=0; text4="";}
    
    if (CloseAllOpenTradesNow==True) {
	 text3 = "Closing orders because CloseAllOpenTradesNow=True";	 
	 CloseAll();
	 ContinueOpening=False;
	 DontStart=1;
   }
//

//-----------------IF ONE ORDER IS CLOSED WE CLOSED THE REMAINED-----------------------------------
//
   if (PreviousOpenOrders>OpenOrders) {CloseAll();}

//-----------------------------------FREE MARGIN PROTECTION---------------------------------------------
//
   if (AccountFreeMargin() < (AccountBalance()*MarginProtection/100)){ StopTrading=1; }
   else { StopTrading=0; }
   if (AccountBalance()-AccountEquity() > (AccountBalance()*FloatingLossProtection)/100){ StopTrading2=1; }
   else { StopTrading2=0; }
//------------------------------------------------------------------------------------------------------
//
//----------------------- TimeFilter Function ----------------------------------------------------------  

bool TradingTime=false;

if(UseTimeFilter)
{
   int iHour=TimeHour(LocalTime());
   int ValidTradeTime = F_ValidTradeTime(iHour);
   if(ValidTradeTime==true) { TradingTime=true;}
}
else {TradingTime=true;}
///
///------------------- IF CONTINUE OPENING---------------------------------------------------------------
   
   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   if (OpenOrders==0 && (Manual==1 || StopTrading==1 || StopTrading2==1 || DontStart==1 || DontStart2==1 || TradingTime==false))
   {
	  ContinueOpening=False;
   } 
   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }
   if (AutoSetup==true)
   {
      
      SafeTradingRange=DinamicRangeCalculation();
      Pips=MathCeil(SafeTradingRange/MaxTrades);
      TakeProfit=(Pips*TakeProfitMT);
      PipsSecureProfit=MathCeil(Pips*SecureProfitMT);
      Print(" SafeTradingRange=",SafeTradingRange," Pips Separation=",Pips," TakeProfit=",TakeProfit," PipsSecureProfit=",PipsSecureProfit);   
   }
   else
   {
    if ( OpenOrders==0 ){ TakeProfit=TakeProfit1; }
    if ( OpenOrders==1 ){ TakeProfit=TakeProfit2; Pips=Pips1; }
    if ( OpenOrders==2 ){ TakeProfit=TakeProfit3; Pips=Pips2; }
    if ( OpenOrders==3 ){ TakeProfit=TakeProfit4; Pips=Pips3; }
    if ( OpenOrders==4 ){ TakeProfit=TakeProfit5; Pips=Pips4; }
    if ( OpenOrders==5 ){ TakeProfit=TakeProfit6; Pips=Pips5; }
    if ( OpenOrders==6 ){ TakeProfit=TakeProfit7; Pips=Pips6; }
    if ( OpenOrders==7 ){ TakeProfit=TakeProfit8; Pips=Pips7; }
    if ( OpenOrders==8 ){ TakeProfit=TakeProfit9; Pips=Pips8; }
    if ( OpenOrders>=9 ){ TakeProfit=TakeProfit10; Pips=Pips9; }
   } 
//
//=============== SWITCH TO OPEN ORDERS BASED ON ===========================================================
//
   if (OpenOrders<1 && Manual==0) 
   {
    
     switch (OpenOrdersBasedOn)
     {
	     case 0: 
	        myOrderTypetmp=OpenOrdersBasedOnMACD();OrdersBasedOn="MACD"; break;
	     case 1: 
	        myOrderTypetmp=OpenOrdersBasedOnPivot();OrdersBasedOn="Pivot Lines TimeZone"; break;
	     case 2:
	        myOrderTypetmp=OpenOrdersBasedOnSupRes();OrdersBasedOn="Support and Resistance"; break;
	     case 3:
	        myOrderTypetmp=OpenOrdersBasedOnTrendRSX();OrdersBasedOn="Turbo-JRSX"; break;
	     case 4:
	        myOrderTypetmp=OpenOrdersBasedOni_TrendRSI();OrdersBasedOn="i_Trend and RSI"; break;	        
	     case 5:
	        myOrderTypetmp=OpenOrdersBasedOni_TrendRSISto();OrdersBasedOn="i_Trend, RSI and Stochastic"; break;
	     case 6:
	        myOrderTypetmp=OpenOrdersBasedOni_TrRSIStoMFI();OrdersBasedOn="i_Trend,RSI,Stochastic and MFI"; break;
	     case 7:
           myOrderTypetmp=OpenOrdersBasedOnPSAR();OrdersBasedOn="Parabolic SAR";break;
        case 8:
           myOrderTypetmp=OpenOrdersBasedOnBrainTrend1Sig();OrdersBasedOn="BrainTrend1Sig";break;	   	        
        case 9:
           myOrderTypetmp=OpenOrdersBasedOnRSI2MA();OrdersBasedOn="RSI2MA";break;	
        case 10:
           myOrderTypetmp=OpenOrdersBasedOnMovingAverage();OrdersBasedOn="Moving Average";break;	 	           	        
        case 11:
           myOrderTypetmp=OpenOrdersBasedOnCCI();OrdersBasedOn="CCI";break;	 
        case 12:
           myOrderTypetmp=OpenOrdersBasedOnBullsandBears();OrdersBasedOn="Bulls and Bears";break;
        case 13:
           myOrderTypetmp=OpenOrdersBasedOnTrendManager();OrdersBasedOn="Trend Manager";break;
        case 14:
           myOrderTypetmp=OpenOrdersBasedOnFXFish();OrdersBasedOn="FXFish";break;
        case 15:   
           myOrderTypetmp=OpenOrdersBasedOnFXFish2MA();OrdersBasedOn="FXFish2-MA";break;	 		 	    
        case 16:
           myOrderTypetmp=OpenOrdersBasedOnFibPivots();OrdersBasedOn="FibPivots";break;	 		 	                    
        case 17:
           myOrderTypetmp=OpenOrdersBasedOnFib4Hour();OrdersBasedOn="Fib4Hour";break;	 		 	                    
        case 18:
           myOrderTypetmp=OpenOrdersBasedOnZLS();OrdersBasedOn="Zerolagstochs";break;	 		 	                            
        case 19:
           myOrderTypetmp=OpenOrdersBasedOnChopZone();OrdersBasedOn="ChopZone";break;	 		 	                            
        case 20:
           myOrderTypetmp=OpenOrdersBasedOnDZRSI();OrdersBasedOn="Dynamic Zone RSI";break;
        case 21:
           myOrderTypetmp=OpenOrdersBasedOnProfitGen();OrdersBasedOn="Profit Generator";break;	 		 	                            
	     case 22:
           myOrderTypetmp=OpenOrdersBasedOnBBandsRSI();OrdersBasedOn="Bollinger Bands and RSI";break;
	     case 23:
	        myOrderTypetmp=OpenOrdersBasedOn_Firebird();OrdersBasedOn="Firebird"; break;   
	     case 24:
	        myOrderTypetmp=OpenOrdersBasedOn_Phoenix();OrdersBasedOn="Phoenix";break;         
	     case 25:
	        myOrderTypetmp=OpenOrdersBasedOnIchimoku();OrdersBasedOn="Ichimoku";break;    
	     default: 
	        myOrderTypetmp=OpenOrdersBasedOn_Phoenix();OrdersBasedOn="Phoenix"; break;	          
	  }


//=====================If ReverseCondition=True We invert the signals================================
//
	  if (ReverseCondition)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; }}
	  }
//====================  H4 Ema Trend confirmation  ===================================================
      
       myOrderType=0;
       if (myOrderTypetmp==1 && TrendType==1) {myOrderType=1;}
       if (myOrderTypetmp==2 && TrendType==2) {myOrderType=2;}
//
//==========================Positive Swap Filter======================================================
//
     if (TradePositiveSwapOnly==true)
     {
      if (swapshort<=0 && myOrderType==1) { myOrderType=0;}
      if (swaplong<=0 && myOrderType==2) { myOrderType=0;}
     }
//===========================Direction Filter==========================================================
   if (FixedDirection==1)
   {
     if (myOrderType==1) { myOrderType=0;}
   }
   if (FixedDirection==2)
   {
    if (myOrderType==2) { myOrderType=0;}
   }
  }
//   
//=========================  SWAP CALCULATION ========================================================
//
   if (TradePositiveSwapOnly==true) 
   {
    if (swapshort<=0) { WeTradeIt="only Long Signals";   }
    if (swaplong<=0) { WeTradeIt="only Short Signals";}
    if (swaplong<=0 && swapshort<=0) { WeTradeIt="No Tradeable Pair, no positive Swap";   }
   }
   if (FixedDirection==1){ WeTradeIt="only Long Signals";}
   if (FixedDirection==2){ WeTradeIt="only Short Signals";}
   if (myOrderType==1) { TradeDirection="Short"; }
   if (myOrderType==2) { TradeDirection="Long"; }
   if (myOrderType==0) { TradeDirection="Waiting Signal"; }
   if (OpenOrders==0 && TradingTime==false){ TradeDirection="Non Trading Hours!!";}
   if (TrendType==0) { TrendTxt = "Undefined - Ranging"; }
   if (TrendType==1) { TrendTxt = "Downtrend"; }
   if (TrendType==2) { TrendTxt = "Uptrend"; }
//----------------------------------------------------------------------------------------------------
//  
//------- If we have opened positions we take care of them  -------------------------------------------
// 
   double TrailingStop=0;
   Pips_even=Pips;
   if (OpenOrders>1 && Use_ExitConfirmation) {TrailingStop=0;} else {TrailingStop=Trailing_Stop;if (BreakevenTrail>0){Pips_even=BreakevenTrail;}}
   cnt=OrdersTotal();
   while(cnt>=0)
   {
     dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) // && Reversed==False) 
	  {
        //Print("Ticket ",OrderTicket()," modified.");	     
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if ((OrderOpenPrice()-Ask)>=(TrailingStop*Point+Pips_even*Point)) 
				  {						
					 if (OrderStopLoss()>(Ask+Point*TrailingStop) || OrderStopLoss()==0)
					 {					
					    dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if ((Bid-OrderOpenPrice())>=(TrailingStop*Point+Pips_even*Point)) 
				{
					if (OrderStopLoss()<(Bid-Point*TrailingStop)) 
					{
					   dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
      cnt--;
   }
//
//
//==========================================Secure Profit Level 2(Emergency Exit) ==============================================     
//
//
   ProtectionActivate=0;
   if (OpenOrders>=(MaxTrades-OrderstoProtect) && AccountProtection==1) {ProtectionActivate=1;}
   if (AccountFreeMargin() < (AccountBalance()*MarginProtection2/100)) {ProtectionActivate=1;}
   if (ForceAccountProtection==1) {ProtectionActivate=1;}
   if (ProtectionActivate==1)
   {
	  Profit=0;
	  TotalProfit=0;
     LastTicket=0;
	  LastType=0;
	  LastClosePrice=0;
	  LastLots=0;
	  TotalSwap=0;
	  TotalCommission=0;	
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {
	    dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {			
			LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{			
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			   TotalSwap=TotalSwap+OrderSwap();
			   TotalCommission=TotalCommission+OrderCommission();
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				TotalSwap=TotalSwap+OrderSwap();
				TotalCommission=TotalCommission+OrderCommission();
			}
	  	  }
	  }
	  SecureProfit=PipsSecureProfit*(PipValue*lotsi);
	  SecureProfit=NormalizeDouble(SecureProfit,2);
	  Profit=(NormalizeDouble((Profit*PipValue),2))+TotalCommission;
	  TotalProfit=Profit+TotalSwap+TotalCommission;
	  if (TotalSwap<0) {Profit=TotalProfit;}
	  Print(" SafeTradingRange= ",SafeTradingRange," Pips Separation= ",Pips," TakeProfit= ",TakeProfit," PipsSecureProfit= ",PipsSecureProfit
	  ," SecureProfit=$",SecureProfit," Profit/Loss=$",TotalProfit);
	  if (AllSymbolsProtect==1) { tmp=AccountBalance(); }
	  else { tmp=SecureProfit; }
	  if (Profit>=tmp) 
	  {
	     dummyResult = OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
		  CloseAll();
		  ContinueOpening=False;
		  myOrderType=0;
		  return(0);
	  }
   }
//
//========================================= End Secure Profit Level 2(Emergency Exit) ==============================================     
//
//
//==========================================Exit Confirmation Secure Profit Level 1 ================================================
//  
   if (Use_ExitConfirmation && OpenOrders>=1)
   {
	  Profit=0;
	  TotalProfit=0;
     LastTicket=0;
	  LastType=0;
	  LastClosePrice=0;
	  LastLots=0;
	  TotalSwap=0;
	  TotalCommission=0;
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {
	    dummyResult = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {			
			LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{				
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			   TotalSwap=TotalSwap+OrderSwap();
			   TotalCommission=TotalCommission+OrderCommission();
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				TotalSwap=TotalSwap+OrderSwap();
				TotalCommission=TotalCommission+OrderCommission();
			}
	  	  }
	  }
	  SecureProfit=PipsSecureProfit*(PipValue*lotsi);
	  SecureProfit=NormalizeDouble(SecureProfit,2);
	  Profit=(NormalizeDouble((Profit*PipValue),2))+TotalCommission;
	  TotalProfit=Profit+TotalSwap+TotalCommission;
	  if (TotalSwap<0) {Profit=TotalProfit;}
	  tmp=SecureProfit*OpenOrders;
	  ExitConfirmation=1;
	  if (Profit>=tmp)
	  {  TrailingStop=15;
	     if (Use_ExitConfirmation) {ExitConfirmation=Exit_Confirmation();}
	     if (ExitConfirmation==1) {dummyResult = OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
		  CloseAll();
		  ContinueOpening=False;
		  myOrderType=0;
		  return(0);}
	  } else TrailingStop=0;
	  if (CloseAllProfitTradesNow) 
	  {
	    SecureProfit2=MinPipsProfit*(PipValue*lotsi);
	    if (Profit>=SecureProfit2) 
	      {
	       CloseAll();
	       ContinueOpening=False;
		    myOrderType=0;
		    return(0);
		   }
	  }
	  if (CloseOnTrendRev)
	  	  {
	  	    if (myOrderType==1 && TrendType!=1 && Profit>=SecureProfit2) 
	  	      {
	          CloseAll();
	          ContinueOpening=False;
		       myOrderType=0;
		       return(0);
		      }
	  	    if (myOrderType==2 && TrendType!=2 && Profit>=SecureProfit2) 
	  	      {
	          CloseAll();
	          ContinueOpening=False;
		       myOrderType=0;
		       return(0);
		      }
	  	  }   
    }
	    
//================================================End Exit Confirmation Secure Profit Level 1 ==============================================  
//
     
      if (SpreadProtection && Spread>NormalSpread+PipTolerance){DontContinue=1;} else {DontContinue=0;}
      if (OpenOrders==0 && Manual==1) { text="Manual=1, Automatic Starting Disable                  "; }
      else {if (OpenOrders==0 && StopTrading==1) { text="Low Free Margin Available. We will not open new trades";
      if (OpenOrders==0 && StopTrading2==1) { text="Excessive Floating Loss. We will not open new trades"; }}
        else { if (myOrderType==3) { text="No conditions to open trades                         "; }
	   else { text="                                                     "; }}
	   if (DontContinue==1) {text="WIDEN SPREAD - Spread protection is active"; }
	   if (ProtectionActivate==1) { text2="Account Protection is active,   "; }
	     else { text2="                                           ";}}
	     Comment("Normal Spread=",NormalSpread," Actual Spread=",Spread,"  Worst Spread=",WorstSpread,"  PipValue=$",PipValue," Account Type: ",AccountText,"\nSignal used to open orders: ",OrdersBasedOn,text6,"LastPrice=",
	     LastPrice," Previous open orders=",PreviousOpenOrders,"\nSwap Short= ",swapshort," Swap Long= ",swaplong,
	     "\nSwap Profit/Loss on open orders= $",TotalSwap,"\nTotal Commissions on open orders= $",TotalCommission,"\nTotal Profit/Loss on open orders= $",TotalProfit,"\nWe trade it: ",WeTradeIt,
	     "\nContinue opening=",ContinueOpening,"\nOrderType= ",TradeDirection,
	     "\n4H Trend : ",TrendTxt,"\nLots=",lotsi,"\n",text,"\n",text2,"\n",text3,"\n",text4);

      if (myOrderType==1 && ContinueOpening && DontContinue==0) 
      {	EnterConfirmation=1;
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (StopLoss==0) { sl=0; }
		    else { sl=SellPrice+StopLoss*Point;  }
		    if (OpenOrders>0) 
		    { if (Use_EnterConfirmation) {EnterConfirmation=Enter_Confirmation();}
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      if (UseFibonacciProgression) {mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;}
			   else { mylotsi=NormalizeDouble(mylotsi*LotIncreaseFactor,2);}
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (EnterConfirmation==1) {dummyResult = OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"TER"+MagicNumber,MagicNumber,0,Red);		    		    
		    return(0);}
	     }
      }
      
      if (myOrderType==2 && ContinueOpening && DontContinue==0) 
      { EnterConfirmation=1;
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     { 		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (StopLoss==0)  { sl=0; }
		    else { sl=BuyPrice-StopLoss*Point; }
		    if (OpenOrders>0) 
		    { if (Use_EnterConfirmation) {EnterConfirmation=Enter_Confirmation();}
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   if (UseFibonacciProgression) {mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;}
			   else { mylotsi=NormalizeDouble(mylotsi*LotIncreaseFactor,2);}
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (EnterConfirmation==1) {dummyResult = OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"TER"+MagicNumber,MagicNumber,0,Blue);		    
		    return(0);}
	     }
      }   

   return(0);
  }
//=============== FUNCTION VALID TRADE TIME =====================================================================================================================================================================================

bool F_ValidTradeTime (int iHour)
   {
      if(((iHour >= TradeFrom1) && (iHour <= (TradeUntil1-1)))||((iHour>= TradeFrom2) && (iHour <= (TradeUntil2-1)))||((iHour >= TradeFrom3)&& (iHour <= (TradeUntil3-1)))||((iHour >= TradeFrom4) && (iHour <=(TradeUntil4-1))))
      {
       return (true);
      }
      else
       return (false);
   }  
//=========================END FUNCTION VALID TRADE TIME==========================================================================================================================================================================
//
//
//=============== Function Close all Open Orders ==========================================================================
//
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    dummyResult = OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;
    if ((OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) || AllSymbolsProtect==1)
    {
     switch(type)
     {
      //Close opened long positions
      case OP_BUY       : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),slippage,Blue);
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),slippage,Red);
                          
     }
    }
  }
  myOrderType=0;
}
//
//========================= Enter iStochastic Confirmation ==============================================
//
int Enter_Confirmation() 
{    
 int lEnterConfirmation=0;    
 double lStoch1=0, lStoch2=0;    
 
 lStoch1= iStochastic(NULL,Timeframe1,5,3,3,MODE_SMA,0,MODE_MAIN,0);
 lStoch2= iStochastic(NULL,Timeframe1,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);    
 if (myOrderType==1 && lStoch1<lStoch2) { lEnterConfirmation=1; }  // Confirm SELL Orders
 if (myOrderType==2 && lStoch1>lStoch2) { lEnterConfirmation=1; }  // Confirm BUY Orders   
 return(lEnterConfirmation);
}
//=========================End Enter iStochastic Confirmation ==============================================
//
//========================= Exit iStochastic Confirmation ==============================================
//
int Exit_Confirmation() 
{    
 int lExitConfirmation=0;    
 double lStoch1=0, lStoch2=0;    
 
 lStoch1= iStochastic(NULL,Timeframe2,5,3,3,MODE_SMA,0,MODE_MAIN,0);
 lStoch2= iStochastic(NULL,Timeframe2,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);    
 if (myOrderType==1 && lStoch1>lStoch2) { lExitConfirmation=1; }  // Close SELL Orders   
 if (myOrderType==2 && lStoch1<lStoch2) { lExitConfirmation=1; }  // Close BUY Orders 
 return(ExitConfirmation);
}
//=========================End Exit iStochastic Confirmation ==============================================
//
//=========================DINAMIC RANGE CALCULATION====================================================
int DinamicRangeCalculation()
{
   int RAvg=0, Rmax=0;
   int lSafeTradingRange=0;
   int MaxRange=0;
   int i=0;
   i=1;for(;;)
     { 
      i++;
      Rmax   =  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      RAvg   = RAvg + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      if (Rmax>WorstRange) {WorstRange=(Rmax);}
      if (i>719) break;
      }         
   RAvg  = RAvg/720; 
   lSafeTradingRange =MathCeil(WorstRange*SafeRangeFactor);
   if (lSafeTradingRange<SafeMinRange) {lSafeTradingRange = SafeMinRange;}
   text6 =  "\nAverage Day Range: " +  RAvg + "\n"  + 
            "Worst Diary Range  : " +  WorstRange  + "\n" +
            "Safe Trading Range : " +  lSafeTradingRange  + "\n";       
return(lSafeTradingRange);
}
//=========================END DINAMIC RANGE CALCULATION================================================================
//
//=========================SIGNAL SECTION===============================================================================
//             
// FROM THIS SECTION I WILL INSERT ALL THE POSSIBLE FUNCTIONS TO
// MAKE THE DECISION IF WE START LONG OR SHORT
//
//======================================================================================================================
//
//------------------------- If OpenOrdersBasedOnMACD=0 ----------------------------------------------------------------
//
int OpenOrdersBasedOnMACD()
{
int lmyOrderTypetmp=0;
if (MACD_Mode==1)
{
	if (iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1)) { lmyOrderTypetmp=2; }
	if (iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0)<iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1)) { lmyOrderTypetmp=1; }
}
if (MACD_Mode==2)
{
   double Trigger0=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0);
   double Trigger1=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1);
   double Trigger2=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,2);

if( (Trigger0>0) && (Trigger1>0)  &&  (Trigger2>0)) {lmyOrderTypetmp=2;}   // is well above zero
if( (Trigger0<0) && (Trigger1<0)  &&  (Trigger2<0)) {lmyOrderTypetmp=1;}   // is well below zero
}
if (MACD_Mode==3)
{
   double MacdCurrent, MacdPrevious, SignalCurrent, SignalPrevious, MaCurrent, MaPrevious;

   MacdCurrent=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,EMAperiod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,EMAperiod,0,MODE_EMA,PRICE_CLOSE,1);

if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious &&
MathAbs(MacdCurrent)>(3*Point) && MaCurrent>MaPrevious){lmyOrderTypetmp=2;}
    
if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
MacdCurrent>(3*Point) && MaCurrent<MaPrevious) {lmyOrderTypetmp=1;}
}
if (MACD_Mode==4)
{
  if (iCustom(NULL,0,"JMA_MACD",14,26,9,0,0,0,0) > iCustom(NULL,0,"JMA_MACD",14,26,9,0,0,0,1)) { lmyOrderTypetmp=2; }
  if (iCustom(NULL,0,"JMA_MACD",14,26,9,0,0,0,0) < iCustom(NULL,0,"JMA_MACD",14,26,9,0,0,0,1)) { lmyOrderTypetmp=1; }
}
if (MACD_Mode==5)
{
if (iCustom(NULL,0,"Turbo_JMACD",14,26,9,0,0,0,0) > iCustom(NULL,0,"Turbo_JMACD",14,26,9,0,0,0,1)) { lmyOrderTypetmp=2; }
if (iCustom(NULL,0,"Turbo_JMACD",14,26,9,0,0,0,0) < iCustom(NULL,0,"Turbo_JMACD",14,26,9,0,0,0,1)) { lmyOrderTypetmp=1; }
}
return(lmyOrderTypetmp);
}
//        
//--------------------------- End OpenOrdersBasedOnMACD ----------------------------------------------------------------
//
//--------------------------- OpenOrdersBasedOnTrendRSX ----------------------------------------------------------------
//
int OpenOrdersBasedOnTrendRSX()
{
      int lmyOrderTypetmp=0;
      double rsxcurr = iCustom(Symbol(),Period(),"Turbo_JRSX",RSX_Period,0,0);
      double rsxprev = iCustom(Symbol(),Period(),"Turbo_JRSX",RSX_Period,0,1);
      if ((rsxcurr > rsxprev) && (trendtype == 2 || trendtype == 3)) { lmyOrderTypetmp = 2; }
      if ((rsxcurr < rsxprev) && (trendtype == 2 || trendtype == 1)) { lmyOrderTypetmp = 1; }
      return(lmyOrderTypetmp);
     
}
//
//
//--------------------------- End OpenOrdersBasedOnTrendRSX ----------------------------------------------------------------
//
//------------------------- If OpenOrdersBasedOnPivot=1 ----------------------------------------------------------------
//
int OpenOrdersBasedOnPivot()
{
   int lmyOrderTypetmp=0;
   double iTmp=0;
   iTmp = iCustom(Symbol(),0,"Pivot Lines TimeZone",TimeZone,true,false,false,0,0);
	//Print("Pivot:",iTmp);
	if (Close[0]>iTmp) { lmyOrderTypetmp = 2; }
	if (Close[0]<iTmp) { lmyOrderTypetmp = 1; }
	return(lmyOrderTypetmp);
}
//------------------------- End OpenOrdersBasedOnPivot ---------------------------------------------------------------
//
//--------------------------  OpenOrdersBasedOnSupRes=2  -------------------------------------------------------------
//
int OpenOrdersBasedOnSupRes()
{
   int lmyOrderTypetmp=0;
   double iTmpR=0, iTmpS=0;
   iTmpR = iCustom(Symbol(),0,"Support and Resistance",0,0);
   iTmpS = iCustom(Symbol(),0,"Support and Resistance",1,0);

	if (Close[0]==iTmpS) { lmyOrderTypetmp = 1; }
	if (Close[0]==iTmpR) { lmyOrderTypetmp = 2; }
	return(lmyOrderTypetmp);
}
//----------------------------------------------------------------------------------------------------------------------
//
//------------------------- OpenOrdersBasedOni_TrendRSI=3 ----------------------------------------------------------------
//
int OpenOrdersBasedOni_TrendRSI()
{
      int lmyOrderTypetmp=0;
      double Buy1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Buy1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 1, 0);
      double Buy2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Buy2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 1);
      double Buy3_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Buy3_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Sell1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Sell1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 1, 0);
      double Sell2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Sell2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 1);
      double Sell3_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Sell3_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      
      if (Buy1_1 > Buy1_2 && Buy2_1 > Buy2_2 && Buy3_1 > Buy3_2) { lmyOrderTypetmp = 2; }
      if (Sell1_1 < Sell1_2 && Sell2_1 < Sell2_2 && Sell3_1 < Sell3_2) { lmyOrderTypetmp = 1; }
      return(lmyOrderTypetmp);
}
//
//----------------------------------------------------------------------------------------------------------------------
//
//------------------------------OpenOrdersBasedOni_TrendRSISto=4 ---------------------------------------------------------
//
int OpenOrdersBasedOni_TrendRSISto()
{
      int lmyOrderTypetmp=0;
      double Buy1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Buy1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 1, 0);
      double Buy2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Buy2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 1);
      double Buy3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Buy4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Buy5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy5_2 = 80;
      double Buy6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy6_2 = 20;
      double Buy7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Buy7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Sell1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Sell1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 1, 0);
      double Sell2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 0);
      double Sell2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 11, 2, 7, 300, 0, 1);
      double Sell3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Sell4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Sell5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell5_2 = 80;
      double Sell6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell6_2 = 30;
      double Sell7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Sell7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      
      if (Buy1_1 > Buy1_2 && Buy2_1 > Buy2_2 && Buy3_1 > Buy3_2 && Buy4_1 > Buy4_2 && Buy5_1 < Buy5_2 && Buy6_1 > Buy6_2 && Buy7_1 > Buy7_2) { lmyOrderTypetmp = 2; }
      if (Sell1_1 < Sell1_2 && Sell2_1 < Sell2_2 && Sell3_1 < Sell3_2 && Sell4_1 < Sell4_2 && Sell5_1 < Sell5_2 && Sell6_1 > Sell6_2 && Sell7_1 < Sell7_2) { lmyOrderTypetmp = 1; }
      return(lmyOrderTypetmp);
     
}
//
//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//
//
//-----------------------OpenOrdersBasedOni_TrRSIStoMFI=5-------------------------------------
//
int OpenOrdersBasedOni_TrRSIStoMFI()
{
      int lmyOrderTypetmp=0;
      double Buy1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Buy1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 1, 0);
      double Buy2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Buy2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 1);
      double Buy3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Buy4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Buy5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy5_2 = 80;
      double Buy6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy6_2 = 20;
      double Buy7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Buy7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Buy8_1 = iMFI(NULL, 0, 5, 0);
      double Buy8_2 = iMFI(NULL, 0, 5, 1);    
      double Sell1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Sell1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 1, 0);
      double Sell2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Sell2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 1);
      double Sell3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Sell4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Sell5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell5_2 = 80;
      double Sell6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell6_2 = 30;
      double Sell7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Sell7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Sell8_1 = iMFI(NULL, 0, 5, 0);
      double Sell8_2 = iMFI(NULL, 0, 5, 1);
           
      if (Buy1_1 > Buy1_2 && Buy2_1 > Buy2_2 && Buy3_1 > Buy3_2 && Buy4_1 > Buy4_2 && Buy5_1 < Buy5_2 && Buy6_1 > Buy6_2 && Buy7_1 > Buy7_2 && Buy8_1 > Buy8_2) { lmyOrderTypetmp = 2; }
      if (Sell1_1 < Sell1_2 && Sell2_1 < Sell2_2 && Sell3_1 < Sell3_2 && Sell4_1 < Sell4_2 && Sell5_1 < Sell5_2 && Sell6_1 > Sell6_2 && Sell7_1 < Sell7_2 && Sell8_1 < Sell8_2) { lmyOrderTypetmp = 1; }
      return(lmyOrderTypetmp);
}
//
//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//
//=================================FIREBIRD SIGNAL=====OpenOrdersBasedOn_Firebird=6===========================   

int OpenOrdersBasedOn_Firebird()
{  
   int lmyOrderTypetmp=0;
      double myMA =iMA(NULL,MA_timeframe,MA_length,0,MODE_SMA,PRICE_OPEN,0);

   if (myMA*(1+FirebirdPercent/100)<Bid ) { lmyOrderTypetmp=1; } 
   if (myMA*(1-FirebirdPercent/100)>Ask ) { lmyOrderTypetmp=2; }
      
//----------- TrendFollowing=true we invert our signal during news time --------
 
 if (TrendFollowingDuringNewsTime)
 {
 int iHour=TimeHour(LocalTime());
 if ((iHour >= NewsHourFrom) && (iHour <= NewsHourUntil)) {
	  	  if (myOrderType==1) { lmyOrderTypetmp=2; }}
		  else { if (myOrderType==2) { lmyOrderTypetmp=1; }} 
 }  
return(lmyOrderTypetmp);
}
//==============================END FIREBIRD SIGNAL  =========================================================
//
//
//
//================================PHOENIX SIGNALS===OpenOrdersBasedOn_Phoenix=20  =============================
//
int OpenOrdersBasedOn_Phoenix()
{
int lmyOrderTypetmp=0;
//=====================SIGNAL1=======================

bool BuySignal1=false, SellSignal1=false;

double HighEnvelope1 = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,PhoenixPercent,MODE_UPPER,1);
double LowEnvelope1  = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,PhoenixPercent,MODE_LOWER,1);
double CloseBar1     = iClose(NULL,0,1);

if(UseSignal1)
{
   if(CloseBar1 > HighEnvelope1) {SellSignal1 = true;} 
   if(CloseBar1 < LowEnvelope1)   {BuySignal1  = true;}
}
else {SellSignal1=true;BuySignal1=true;}



//=====================SIGNAL2=======================

bool BuySignal2=false, SellSignal2=false;

double SMA1=iMA(NULL,0,SMAPeriod,0,MODE_SMA,5,1);
double SMA2=iMA(NULL,0,SMAPeriod,0,MODE_SMA,5,SMA2Bars);

if(UseSignal2)
{
   if(SMA2-SMA1>0) {BuySignal2  = true;}
   if(SMA2-SMA1<0) {SellSignal2 = true;}
}
else {SellSignal2=true;BuySignal2=true;}



//=====================SIGNAL3=======================

bool BuySignal3=false, SellSignal3=false;

double OsMABar2=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,2);
double OsMABar1=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,1);

if(UseSignal3)
{
   if(OsMABar2 > OsMABar1)  {SellSignal3 = true;}
   if(OsMABar2 < OsMABar1)  {BuySignal3  = true;}
}
else {SellSignal3=true;BuySignal3=true;}


      
//=====================SIGNAL4=======================  

   double diverge;
   bool BuySignal4=false,SellSignal4=false;
   
   diverge = divergence(Fast_Period, Slow_Period, Fast_Price, Slow_Price,0);

if(UseSignal4)
{
   if(diverge >= DVBuySell && diverge <= DVStayOut)
       {BuySignal4 = true;}
   if(diverge <= (DVBuySell*(-1)) && diverge >= (DVStayOut*(-1))) 
       {SellSignal4 = true;} 
}       
else {SellSignal4=true;BuySignal4=true;}

if((SellSignal1==true) && (SellSignal2==true) && (SellSignal3==true) && (SellSignal4==true)) { lmyOrderTypetmp=1; }
if((BuySignal1==true) && (BuySignal2==true) && (BuySignal3==true) && (BuySignal4==true)) { lmyOrderTypetmp=2; }

return(lmyOrderTypetmp);
}

//+------------------------------------------------------------------+

double divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
//----
    double maF1, maF2, maS1, maS2;
    double dv1, dv2;
//----
    maF1 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos);
    maS1 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos);
    dv1 = (maF1 - maS1);

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);
    dv2 = ((maF1 - maS1) - (maF2 - maS2));
//----
    return(dv1 - dv2);
  }
 
//===========================================END PHOENIX SIGNALS=================================================== 
//
//
//
//===========================OpenOrdersBasedOnPSAR=8 ======================================================
//
int OpenOrdersBasedOnPSAR()
{
   int lmyOrderTypetmp=0;
   if (iSAR(NULL,0,0.02,0.2,1) <= Low[1]  && iSAR(NULL,0,0.02,0.2,0) > High[0]) { lmyOrderTypetmp=1; }//SELL
	if (iSAR(NULL,0,0.02,0.2,1) >= High[1] && iSAR(NULL,0,0.02,0.2,0) < Low[0] ) { lmyOrderTypetmp=2; }//BUY
 	return(lmyOrderTypetmp);
}
//
//========================================================================================================
//
//
//
//=====================OpenOrdersBasedOnBrainTrend1Sig=9 ============================
//
int OpenOrdersBasedOnBrainTrend1Sig()
{
   int lmyOrderTypetmp=0;
   double BT1, BT2, BT3, BT4;
   BT1=iCustom(NULL,0,"BrainTrend1Stop",10,0,0);
   BT2=iCustom(NULL,0,"BrainTrend1Stop",10,0,1);      
   BT3=iCustom(NULL,0,"BrainTrend1Stop",10,1,0);
   BT4=iCustom(NULL,0,"BrainTrend1Stop",10,1,1);                     
   if (BT1 && !BT2) lmyOrderTypetmp=1;     
   if (BT3 && !BT4) lmyOrderTypetmp=2; 
   return(lmyOrderTypetmp);
}
//
//==================================================================================
//
//
//
//================== OpenOrdersBasedOnRSI2MA=10 ====================================
//
int OpenOrdersBasedOnRSI2MA()
{
   int lmyOrderTypetmp=0;  
   double ma1, ma2, ma1b4, ma2b4;
   
   ma1=iCustom(Symbol(),0,"RSI 2MA",14,21,9,70,30,"SMA","--",0,3,1,1);
   ma2=iCustom(Symbol(),0,"RSI 2MA",14,21,9,70,30,"SMA","--",0,3,2,1);
   ma1b4=iCustom(Symbol(),0,"RSI 2MA",14,21,9,70,30,"SMA","--",0,3,1,2);
   ma2b4=iCustom(Symbol(),0,"RSI 2MA",14,21,9,70,30,"SMA","--",0,3,2,2);

   if(ma1b4>=ma2b4 && ma1<ma2)  lmyOrderTypetmp=1;
   if(ma1b4<=ma2b4 && ma1>ma2)  lmyOrderTypetmp=2;

   return(lmyOrderTypetmp);
}
//
//=================================================================================
//
//
//
//===================== OpenOrdersBasedOnMovingAverage=11 =========================
//
int OpenOrdersBasedOnMovingAverage()
{
   int lmyOrderTypetmp=0;
   double ma;
   
   ma=iMA(NULL,0,12,6,MODE_SMA,PRICE_CLOSE,0);
   
   // sell
   if(Open[1]>ma && Close[1]<ma) lmyOrderTypetmp=1;
   
   // buy
   if(Open[1]<ma && Close[1]>ma) lmyOrderTypetmp=2;
   
   return(lmyOrderTypetmp);
}
//
//================================================================================
//
//
//
//========================== OpenOrdersBasedOnCCI=12 =============================
//
int OpenOrdersBasedOnCCI()
{
   int lmyOrderTypetmp=0;
   double cci, ccib4;
   
   cci  =iCCI(Symbol(),0,8,PRICE_CLOSE,1);  
   ccib4=iCCI(Symbol(),0,8,PRICE_CLOSE,2);  
   
   if(ccib4>=0 && cci<0)  lmyOrderTypetmp=1;
   
   if(ccib4<=0 && cci>0) lmyOrderTypetmp=2;
 
   return(lmyOrderTypetmp);  
}
//
//===============================================================================
//
//
//
//==================== OpenOrdersBasedOnBullsandBears=13 ========================
//
int OpenOrdersBasedOnBullsandBears()
{
   int lmyOrderTypetmp=0;
   double bull, bear;
   
   bull = iBullsPower(NULL,0,5,PRICE_CLOSE,1);
   bear = iBearsPower(NULL,0,5,PRICE_CLOSE,1);
   
   // sell
   if (bull+bear<0) lmyOrderTypetmp=1;
   
   // buy
   if (bull+bear>0) lmyOrderTypetmp=2;
   
   return(lmyOrderTypetmp);
}
//
//=====================================================================================
//
//
//
//====================== OpenOrdersBasedOnTrendManager=14 =============================
//
int OpenOrdersBasedOnTrendManager()
{
   int lmyOrderTypetmp=0;
   double tm0, tm1;

   tm0=iCustom(Symbol(),0,"Trend Manager",0.0007,23,PRICE_OPEN,84,PRICE_OPEN,500,0,1);
   tm1=iCustom(Symbol(),0,"Trend Manager",0.0007,23,PRICE_OPEN,84,PRICE_OPEN,500,1,1);

   // sell
   if(tm1<tm0) {lmyOrderTypetmp=1;}
   
   // buy 
   if(tm1>tm0) {lmyOrderTypetmp=2;}

   return(lmyOrderTypetmp);
}
//
//======================================================================================
//
//
//
//===================== OpenOrdersBasedOnFXFish=15 =====================================
//
int OpenOrdersBasedOnFXFish()
{
 int lmyOrderTypetmp=0;
 double tm0, tm1;
 
 tm0=iCustom(Symbol(),0,"FX_FISH",10,0,True,False,0,1);
 tm1=iCustom(Symbol(),0,"FX_FISH",10,0,True,False,1,1);
 
 // sell
 if(tm1<tm0) lmyOrderTypetmp=1;
   
 // buy 
 if(tm1>tm0) lmyOrderTypetmp=2;

 return(lmyOrderTypetmp);
}
//
//================================================================
//
//===================== OpenOrdersBasedOnFXFish_2MA=====================================
//
int OpenOrdersBasedOnFXFish2MA()
{
 int lmyOrderTypetmp=0;
 double tm0, tm1;
 double line;
 
 tm0=iCustom(Symbol(),0,"FX_FISH_2MA",10,0,False,False,9,45,"-","-",0,3,3,0);
 tm1=iCustom(Symbol(),0,"FX_FISH_2MA",10,0,False,False,9,45,"-","-",0,3,4,0);
 line=iCustom(Symbol(),0,"FX_FISH_2MA",10,0,False,False,9,45,"-","-",0,3,2,0);
 
 // sell
 if(line<tm0) 
 {
  lmyOrderTypetmp=1;
 }
   
 // buy 
 if(line>tm0) 
 {
  lmyOrderTypetmp=2;
 }

 return(lmyOrderTypetmp);
}
//================================================================
//
//
//
//==================OpenOrdersBasedOnFibPivots========================
//
int OpenOrdersBasedOnFibPivots() 
{    
 int lmyOrderTypetmp=0;    
 double RSI=0, lPivot=0, Range=0, EnterLong=0, EnterShort=0;    
 RSI = iRSI(NULL, PERIOD_D1, 14, PRICE_CLOSE, 0);    
 
 if (RSI > 50.0)    
 {    
  lPivot = ((High[1] + Low[1] + Close[1]) / 3);    
  Range = (High[1] - Low[1]);    
  EnterLong = (lPivot - (Range * 0.618));    
 }    
 
 if (RSI < 50.0)    
 {    
  lPivot = ((High[1] + Low[1] + Close[1]) / 3);    
  Range = (High[1] - Low[1]);    
  EnterShort = (lPivot + (Range * 0.618));    
 }    
 
 // BUY
 if (RSI > 50.0 && Low[0] < EnterLong) 
 { 
  lmyOrderTypetmp = 2; 
 }    
 
 // SELL
 if (RSI < 50.0 && High[0] > EnterShort) 
 { 
  lmyOrderTypetmp = 1; 
 }    
 
 return(lmyOrderTypetmp); 
} 
//
//================================================================
//
//
//
//================OpenOrdersBasedOnFib4Hour==========================
//
int OpenOrdersBasedOnFib4Hour() 
{    
 int lmyOrderTypetmp=0;    
 double SMA=0, FibLow=0, EnterLong=0, FibHigh=0, EnterShort=0;    
 SMA = iMA(NULL, NULL, 10, 0, MODE_SMA, PRICE_CLOSE, 1);    
 
 if (SMA != NULL && Close[1] > SMA)    
 {    
  FibLow = ((High[1] - Low[1]) * 0.618);    
  EnterLong=(High[1] - FibLow);    
 }    
 
 if (SMA != NULL && Close[1] < SMA)    
 {    
  FibHigh=((High[1] - Low[1]) * 0.618);    
  EnterShort=(Low[1] + FibHigh);    
 }    

 // BUY
 if (Close[1] > SMA && Low[0] < EnterLong) 
 { 
  lmyOrderTypetmp = 2; 
 }    

 // SELL 
 if (Close[1] < SMA && High[0] > EnterShort) 
 { 
  lmyOrderTypetmp = 1; 
 }    
 
 return(lmyOrderTypetmp); 
} 
//
//================================================================
//
//
//
//=================OpenOrdersBasedOnZLS======================
//
int OpenOrdersBasedOnZLS() 
{    
 int lmyOrderTypetmp=0;    
 double iTmpU=0, iTmpD=0;    
 
 iTmpD = iCustom(Symbol(), NULL, "Zerolagstochs", 0, 0);    
 iTmpU = iCustom(Symbol(), NULL, "Zerolagstochs", 1, 0);    

 // SELL
 if (iTmpU>iTmpD) { lmyOrderTypetmp = 1; }     
 
 // BUY
 if (iTmpU<iTmpD) { lmyOrderTypetmp = 2; }     
 
 return(lmyOrderTypetmp); 
} 
//
//================================================================
//
//
//
//=================OpenOrdersBasedOnChopZone========================
//
int OpenOrdersBasedOnChopZone()
{
   int lmyOrderTypetmp=0;
   double SMA=0, CZIBlue=0, CZIBrown=0;
   
   SMA = iMA(NULL, NULL, 5, 0, MODE_SMA, PRICE_CLOSE, 1);
   CZIBlue = iCustom(NULL, NULL, "CZI", 3, 1); 
   CZIBrown = iCustom(NULL, NULL, "CZI", 7, 1); 
   
   // BUY
   if (Close[1] > SMA && CZIBlue == 1) { lmyOrderTypetmp = 2; }
   
   // SELL
   if (Close[1] < SMA && CZIBrown ==1) { lmyOrderTypetmp = 1; }
   
   return(lmyOrderTypetmp);
}
//
//================================================================
//
//
//
//==================OpenOrdersBasedOnDZRSI=========================================
//
int OpenOrdersBasedOnDZRSI()
{
   int lmyOrderTypetmp=0;
   double iTmpMA=0, iTmpU=0; iTmpL=0;

   iTmpMA = iCustom(Symbol(), NULL, "Dynamic Zone RSI", 14, 20, 5, 0, 0);
   iTmpU = iCustom(Symbol(), NULL, "Dynamic Zone RSI", 14, 20, 5, 1, 0);
   iTmpL = iCustom(Symbol(), NULL, "Dynamic Zone RSI", 14, 20, 5, 2, 0);

   // BUY
   if (iTmpMA < iTmpL) { lmyOrderTypetmp = 2; }

   // SELL
   if (iTmpMA > iTmpU) { lmyOrderTypetmp = 1; }

   return(lmyOrderTypetmp);
}
//===================================================================================  

//==================OpenOrdersBasedOnProfitGenerator=====================================================
int OpenOrdersBasedOnProfitGen()
{
int lmyOrderTypetmp=0;
      
if ((High[0]-Low[0])>10*Point && Open[0]<(High[0]+Low[0])/2 && Ask < Open[0]){ lmyOrderTypetmp = 2; }

if ((High[0]-Low[0])>10*Point && Open[0]>(High[0]+Low[0])/2 && Bid > Open[0]){ lmyOrderTypetmp = 1; }

return(lmyOrderTypetmp);
}
//=======================================================================================================

//==================OpenOrdersBasedOnProfitGenerator=====================================================
int OpenOrdersBasedOnBBandsRSI()
{
double BBPercent           =0;      // Percent of penetration outside the bands, example: 0.1,0.2 etc
int    BandsPeriod         =20;     // Bollinger Bands Period
int    BandsShift          =0;      // Bollinger Bands Shift 
double BandsDeviations     =2;      // Bollinger Bands Deviations, takes buy/sell positions when bar or candle is outside the bands
int    BBEMAPeriod         =20;     // EMA Period (center line between bands)
int    RsiHigh             =70;     // RSI to start a short
int    RsiLow              =30;     // RSI to start a Long
int    RSIPeriod           =14;     // RSI Periods
int lmyOrderTypetmp=0;
double BandUpper = iBands(NULL, 0,BandsPeriod,BandsDeviations,BandsShift, PRICE_CLOSE, MODE_UPPER,0);
double BandLower = iBands(NULL, 0,BandsPeriod,BandsDeviations,BandsShift, PRICE_CLOSE, MODE_LOWER,0);
double Ema = iMA(NULL, 0,BBEMAPeriod, 0, MODE_SMA, PRICE_TYPICAL,0);
double Rsi = iRSI(NULL, 0,RSIPeriod, PRICE_CLOSE,0);      
if (BandLower*(1-BBPercent/100) > Ask && Rsi<RsiLow ) {lmyOrderTypetmp=2;}	
if (BandUpper*(1+BBPercent/100) < Bid && Rsi>RsiHigh ) {lmyOrderTypetmp=1;}

return(lmyOrderTypetmp);
}

//============================== OpenOrdersBasedOn Ichimoku Indicator =========================================================================
int OpenOrdersBasedOnIchimoku()
{
double diCustom0=iCustom(NULL, 240, "Ichimoku", 9, 26, 52, 0, 0);
double diCustom1=iCustom(NULL, 240, "Ichimoku", 9, 26, 52, 1, 0);
double diCustom2=iCustom(NULL, 240, "Ichimoku", 9, 26, 52, 1, 0);
double diMA3=iMA(NULL,240,34,0,MODE_EMA,PRICE_CLOSE,0);
double diCustom4=iCustom(NULL, 240, "Ichimoku", 9, 26, 52, 1, 0);
double diCustom5=iCustom(NULL, 240, "Ichimoku", 9, 26, 52, 0, 0);
int lmyOrderTypetmp=0;
if (diCustom0>diCustom1 && diCustom2>diMA3) {lmyOrderTypetmp=2;}	
if (diCustom4>diCustom5) {lmyOrderTypetmp=1;}

return(lmyOrderTypetmp);
}
//============================== End OpenOrdersBasedOn Ichimoku Indicator =========================================================================